<?php
// {{{ requires
require_once(CLASS_REALDIR . "pages/LC_Page.php");
require_once(realpath(dirname( __FILE__)) . "/include.php");
if(ECCUBE_VERSION == '2.11.0' || ECCUBE_VERSION == '2.11.1' || ECCUBE_VERSION == '2.11.2') {
	require_once(DATA_REALDIR. 'module/Request.php');
} else {
	require_once(DATA_REALDIR. 'module/HTTP/Request.php');
}

require_once MODULE_REALDIR . "mdl_asjpayment/inst/install.php";

define ("CHARGE_MAX", 1000000);

class LC_Query_Asjpayment extends SC_Query {
	function query($n ,$arr = "", $ignore_err = false){
		$result = $this->conn->query($n, $arr, $ignore_err);
		return $result;
	}
}

/**
 * ＡＳＪペイメント決済モジュールのページクラス.
 */
class LC_Page_Mdl_Asjpayment_Config extends LC_Page {
	var $objFormParam;
	var $arrErr;
	var $objQuery;
	var $module_name;
	var $module_title;

	/**
	* コンストラクタ
	*
	* @return void
	*/
	function LC_Page_Mdl_Asjpayment_Config() {
		$this->module_name = mdl_asjpayment;
		$this->module_title = "ＡＳＪペイメント決済モジュール";
		$this->objQuery = new SC_Query();
		$this->objSess = new SC_Session();
		$this->objFormParam = new SC_FormParam_Ex();

		$this->arrUpdateFile = array(
			array("src" => MODULE_REALDIR . $this->module_name . "/load_payment_module_pc.php",
				"dst" => HTML_REALDIR . 'shopping/load_payment_module.php'),
			array("src" => MODULE_REALDIR . $this->module_name . "/asjpayment_recv.php",
				"dst" => USER_REALDIR . '/asjpayment_recv.php'),
			array("src" => MODULE_REALDIR . $this->module_name . "/asjpayment_edit.php",
				"dst" => HTML_REALDIR . ADMIN_DIR . 'order/asjpayment_edit.php'),
			array("src" => MODULE_REALDIR . $this->module_name . "/asjpayment_csv.php",
				"dst" => HTML_REALDIR . ADMIN_DIR . 'order/asjpayment_csv.php'),
		);
	}

	/**
	* Page を初期化する.
	*
	* @return void
	*/
	function init() {
		//parent::init();
		// 開始時刻を設定する。
		$this->timeStart = SC_Utils_Ex::sfMicrotimeFloat();
		$this->tpl_authority = $_SESSION['authority'];
		// ディスプレイクラス生成
		$this->objDisplay = new SC_Display_Ex();
		$layout = new SC_Helper_PageLayout_Ex();
		$layout->sfGetPageLayout($this, false, $_SERVER['PHP_SELF'],
		$this->objDisplay->detectDevice());
		// プラグインクラス生成
		$this->objPlugin = new SC_Helper_Plugin_Ex();
		//$this->objPlugin->preProcess($this);
		// 店舗基本情報取得
		$this->arrSiteInfo = SC_Helper_DB_Ex::sfGetBasisData();
		// トランザクショントークンの検証と生成
		//$this->doValidToken();
		//$this->setTokenTo();
		$this->tpl_mainpage = MODULE_REALDIR . $this->module_name. "/config.tpl";
		$this->tpl_subtitle = $this->module_title;
		$this->arrErr = array();
		global $arrPayment;
		$this->arrPayment = $arrPayment;
		global $arrCredit;
		$this->arrCredit = $arrCredit;
		// 不足しているカラムがあれば追加する。
		$this->updateTable();
	}

	/**
	* Page のプロセス.
	*
	* @return void
	*/
	function process() {
		$objView = new SC_AdminView();
		$objQuery = new SC_Query();
		$objInstall = new install($_POST['customize']);

		// パラメータ管理クラス
		$this->initParam();
		// POST値の取得
		$this->objFormParam->setParam($_POST);
		switch($_POST['mode']) {
		case 'edit':
			// 入力エラー判定
			$this->arrErr = $this->checkError();
			// エラーなしの場合にはデータを更新
			if(count($this->arrErr) == 0) {
				// 管理画面カスタマイズをする場合　既存のテンプレートExクラス上書き
				$errmsg = '';
				if(isset($_POST['customize']) && strlen($_POST['customize']) > 0) {
					$errmsg = $objInstall->filecopy();
					if(!empty($errmsg)) {
						$this->tpl_onload = 'alert("'. $errmsg. '");';
					}
				}
				if(empty($errmsg)) {
					// 支払い方法登録
					$this->lfUpdPaymentDB();
					// 設定情報登録
					$this->setConfig();
					if($this->updateFile()) {
						// javascript実行
						$this->tpl_onload = 'alert("登録完了しました。\n基本情報＞支払方法設定より詳細設定をしてください。");';
					} else {
						// javascript実行
						foreach($this->arrUpdateFile as $array) {
							if(!is_writable($array['dst'])) {
								$alert = $array['dst'] . "に書き込み権限を与えてください。";
								$this->tpl_onload.= "alert(\"". $alert. "\");";
							}
						}
					}
				}
			}
			break;
		case 'module_del':
			// 汎用項目の存在チェック
			$objDB = new SC_Helper_DB_Ex();
			if ($objDB->sfColumnExists("dtb_payment", "memo01")) {
				// 支払方法の削除フラグを立てる
				$arrDel = array('del_flg' => "1");
				$this->objQuery->update("dtb_payment", $arrDel, " module_code = ?", array($this->module_name));
			}
			break;
		default:
			// データのロード
			$arrConfig = $this->getConfig();
			$this->objFormParam->setParam($arrConfig);
			break;
		}
		$this->arrForm = $this->objFormParam->getFormParamList();
		$objView->assignobj($this);				//変数をテンプレートにアサインする
		$objView->display($this->tpl_mainpage);	//テンプレートの出力
	}

	/**
	* デストラクタ.
	*
	* @return void
	*/
	//function destroy() {
	//	parent::destroy();
	//}

	/**
	*  パラメータ情報の初期化
	*/
	function initParam() {
		$arrSiteInfo = SC_Helper_DB::sfGetBasisData();
		// デフォルト値
		$arrDefault  = array(
			"credit_url" => "https://www.asjpayment.jp/cgi-bin/ps_payment.cgi"
			, "regular_csv_url" => "https://www.asjpayment.jp/cgi-bin/ps_regular_csv_ec.cgi"
			, "regular_edit_url" => "https://www.asjpayment.jp/cgi-bin/ps_regular_edit_ec.cgi"
			, "credit_link_url" => "https://www.asjpayment.jp/cgi-bin/ps_sales_eccube.cgi"
			, "after_stock" => 0
		);
		$this->objFormParam->addParam("契約者番号", "credit_ip", "10", "KVa", array("EXIST_CHECK","MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("ログイン", "credit_login", "10", "KVa", array("EXIST_CHECK","MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("パスワード", "credit_pass", "16", "KVa", array("EXIST_CHECK","MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("決済URL", "credit_url", "100", "KVa", array("EXIST_CHECK","MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("定期購入CSVURL", "regular_csv_url", "100", "KVa", array("MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("定期購入変更URL", "regular_edit_url", "100", "KVa", array("MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("利用決済", "payment", "", "", array("EXIST_CHECK"));
		$this->objFormParam->addParam("同期URL", "credit_link_url", "100", "KVa", array("MAX_LENGTH_CHECK"));
		$this->objFormParam->addParam("在庫管理", "after_stock", "", "", array("EXIST_CHECK"));
		$this->objFormParam->addParam("カード決済情報を保持する", "card_retention");
		$this->objFormParam->addParam("決済情報保持キー作成用パスワード", "card_retention_pass", "32", "", array("MAX_LENGTH_CHECK", "GRAPH_CHECK"));
		$this->objFormParam->addParam("管理画面をカスタマイズする", "customize");
	}

	/**
	 * エラーチェック
	 */
	function checkError(){
		$arrErr = $this->objFormParam->checkError();
		// 利用クレジット、利用コンビニのエラーチェック
		$arrChkPay = $_POST["payment"];
		// ssl対応判定
		if(!extension_loaded('openssl') and ereg( "^https://", $_POST["url"] )){
			$arrErr["url"] = "このサーバーはSSLに対応していません。<br>httpで接続してください。";
		}
		// 接続チェックを行う
		if(count($arrErr) == 0) $arrErr = $this->chkConnect();
			return $arrErr;
	}

	/**
	 * 接続チェックを行う
	 */
	function chkConnect(){
		$objView = new SC_AdminView();
		$objQuery = new SC_Query();
		$arrRet = array();
		// メールアドレス取得
		$email = $this->objQuery->getone("SELECT email03 FROM dtb_baseinfo");
		return $arrRet;
	}

	// 登録データを読み込む
	function lfLoadData(){
		$this->objFormParam = new SC_FormParam_Ex();
		//データを取得
		$arrRet = lfGetPaymentDB(" AND del_flg = '0'");
		// 値をセット
		$objFormParam->setParam($arrRet[0]);
	}

	/**
	* 設定を保存
	*/
	function setConfig() {
		$sqlval = array();
		$arrConfig = $this->objFormParam->getHashArray();
		// eccube決済モジュールからデータ取得。
		$arrRet = $this->objQuery->select("sub_data", "dtb_module", "module_code = ?", array(MDL_ASJPAYMENT_CODE));
		$arrConfigEc = unserialize($arrRet[0]['sub_data']);
		if(is_array($arrConfigEc['reg']) == true && count($arrConfigEc['reg']) > 0) {
			$arrConfig = array_merge($arrConfig, array('reg' => $arrConfigEc['reg']));
		}
		$sqlval['sub_data'] = serialize($arrConfig);
		$this->objQuery->update("dtb_module", $sqlval, "module_code = ?", array($this->module_name));
	}

	/**
	* 設定を取得する
	*
	* @return array $arrConfig 設定ファイルの配列
	*/
	function getConfig() {
		$arrRet = $this->objQuery->select("sub_data", "dtb_module", "module_code = ?", array($this->module_name));
		$arrConfig = unserialize($arrRet[0]['sub_data']);
		return $arrConfig;
	}

	/**
	* 支払方法DBからデータを取得
	*/
	function lfgetPaymentDB($type){
		$arrRet = array();
		$sql = "SELECT  module_code, memo01, memo05, memo06, memo07, memo08, memo09, memo10
				 FROM dtb_payment WHERE module_code = ? AND memo03 = ?";
		$arrRet = $this->objQuery->getall($sql, array($this->module_name, $type));
		return $arrRet;
	}

	// データの更新処理
	function lfUpdPaymentDB(){
		$objQuery = new SC_Query();
		$objSess = new SC_Session();

		// del_flgを削除にしておく
		$del_sql = "UPDATE dtb_payment SET del_flg = 1 WHERE module_code = ? ";
		$arrDel = array(MDL_EPSILON_CODE);
		$this->objQuery->query($del_sql, $arrDel);
		// データ登録
		foreach($_POST["payment"] as $key => $val){
			// ランクの最大値を取得する
			$max_rank = $this->objQuery->getone("SELECT max(rank) FROM dtb_payment");
			// 支払方法データを取得
			$arrPaymentData = $this->lfGetPaymentDB("AND memo03 = ?", array($val));
			switch($val){
			// クレジットにチェックが入っていればクレジットを登録する
			case 51 :
				$arrData = array(
				"payment_method" => "クレジットカード(ASJペイメント)"	//支払方法
				,"fix" => 3						//
				,"creator_id" => $this->objSess->member_id		//顧客ID
				,"create_date" => "now()"				//作成日
				,"update_date" => "now()"				//更新日
				,"upper_rule" => 1000000				//決済の上限金額
				,"rule_max" => 100					//決済の下限金額
				,"module_code" => $this->module_name			//モジュール名
				,"module_path" => MODULE_REALDIR . "mdl_asjpayment/credit.php"//モジュールの処理を読み込む
				,"memo01" => $_POST["credit_ip"]			//
				,"memo02" => $_POST["credit_url"]			//
				,"memo03" => $val
				,"memo04" => "51"					//
				,"memo05" => $_POST["credit_login"]			//ログインID
				,"memo06" => $_POST["credit_pass"]			//パスワード
				,"memo07" => $_POST["credit_link_url"]			//同期URL
				,"memo08" => $_POST["regular_csv_url"]			//定期購入CSVURL
				,"memo09" => $_POST["regular_edit_url"]			//定期購入変更URL
				,"memo10" => $_POST["after_stock"]			//在庫管理
				,"del_flg" => "0"
				,"charge_flg" => "2"
				,"upper_rule_max" => CHARGE_MAX
				);
				break;
			case 52 :
				$arrData = array(
				"payment_method" => "コンビニ・銀行決済(ASJペイメント)"	//支払方法
				,"fix" => 3						//
				,"creator_id" => $this->objSess->member_id		//顧客ID
				,"create_date" => "now()"				//作成日
				,"update_date" => "now()"				//更新日
				,"charge_flg" => 1					//手数料使用フラグ
				,"charge" => 0						//手数料
				,"upper_rule" => 300000					//決済の上限金額
				,"rule_max" => 100					//決済の下限金額
				,"module_code" => $this->module_name			//モジュール名
				,"module_path" => MODULE_REALDIR . "mdl_asjpayment/credit.php"//モジュールの処理を読み込む
				,"memo01" => $_POST["credit_ip"]			//
				,"memo02" => $_POST["credit_url"]			//
				,"memo03" => $val
				,"memo04" => "52"					//
				,"memo05" => $_POST["credit_login"]			//ログインID
				,"memo06" => $_POST["credit_pass"]			//パスワード
				,"memo07" => $_POST["credit_link_url"]			//同期URL
				,"memo08" => $_POST["regular_csv_url"]			//定期購入CSVURL
				,"memo09" => $_POST["regular_edit_url"]			//定期購入変更URL
				,"memo10" => $_POST["after_stock"]			//在庫管理
				,"del_flg" => "0"
				,"upper_rule_max" => CHARGE_MAX
				);
				break;
			case 54 :
				$rank = $this->objQuery->getone("select id FROM mtb_order_status where id = ?", MTB_ORDER_STATUS_ATODENE_REVIEW);
				if(isset($rank) == FALSE) {
					$max_rank = $this->objQuery->getone("SELECT max(rank) FROM mtb_order_status");
					$arrData2 = array(
					"id" => MTB_ORDER_STATUS_ATODENE_REVIEW
					,"name" => "審査中"
					,"rank" => $max_rank + 1
					);
					$this->objQuery->insert("mtb_order_status", $arrData2);
				}
				SC_DB_MasterData_Ex::clearCache("mtb_order_status");
				$rank = $this->objQuery->getone("select id FROM mtb_customer_order_status where id = ?", MTB_ORDER_STATUS_ATODENE_REVIEW);
				if(isset($rank) ==FALSE) {
					$max_rank = $this->objQuery->getone("SELECT max(rank) FROM mtb_customer_order_status");
					$arrData2 = array(
					"id" => MTB_ORDER_STATUS_ATODENE_REVIEW
					,"name" => "審査中"
					,"rank" => $max_rank + 1
					);
					$this->objQuery->insert("mtb_customer_order_status", $arrData2);
				}
				SC_DB_MasterData_Ex::clearCache("mtb_customer_order_status");

				$arrData = array(
				"payment_method" => "後払い決済 旧(ASJペイメント)"	//支払方法
				,"fix" => 3						//
				,"creator_id" => $this->objSess->member_id		//顧客ID
				,"create_date" => "now()"				//作成日
				,"update_date" => "now()"				//更新日
				,"charge_flg" => 1					//手数料使用フラグ
				,"charge" => 0						//手数料
				,"upper_rule" => 50000					//決済の上限金額
				,"rule_max" => 100					//決済の下限金額
				,"module_code" => $this->module_name			//モジュール名
				,"module_path" => MODULE_REALDIR . "mdl_asjpayment/credit.php"//モジュールの処理を読み込む
				,"memo01" => $_POST["credit_ip"]			//
				,"memo02" => $_POST["credit_url"]			//
				,"memo03" => $val
				,"memo04" => "54"					//
				,"memo05" => $_POST["credit_login"]			//ログインID
				,"memo06" => $_POST["credit_pass"]			//パスワード
				,"memo07" => $_POST["credit_link_url"]			//同期URL
				,"memo08" => $_POST["regular_csv_url"]			//定期購入CSVURL
				,"memo09" => $_POST["regular_edit_url"]			//定期購入変更URL
				,"memo10" => $_POST["after_stock"]			//在庫管理
				,"del_flg" => "1"
				,"upper_rule_max" => CHARGE_MAX
				);
				break;
			case 57 :
				$rank = $this->objQuery->getone("select id FROM mtb_order_status where id = ?", MTB_ORDER_STATUS_ATOBARAI_REVIEW);
				if(isset($rank) == FALSE) {
					$max_rank = $this->objQuery->getone("SELECT max(rank) FROM mtb_order_status");
					$arrData2 = array(
					"id" => MTB_ORDER_STATUS_ATOBARAI_REVIEW
					,"name" => "審査中"
					,"rank" => $max_rank + 1
					);
					$this->objQuery->insert("mtb_order_status", $arrData2);
				}
				SC_DB_MasterData_Ex::clearCache("mtb_order_status");
				$rank = $this->objQuery->getone("select id FROM mtb_customer_order_status where id = ?", MTB_ORDER_STATUS_ATOBARAI_REVIEW);
				if(isset($rank) ==FALSE) {
					$max_rank = $this->objQuery->getone("SELECT max(rank) FROM mtb_customer_order_status");
					$arrData2 = array(
					"id" => MTB_ORDER_STATUS_ATOBARAI_REVIEW
					,"name" => "審査中"
					,"rank" => $max_rank + 1
					);
					$this->objQuery->insert("mtb_customer_order_status", $arrData2);
				}
				SC_DB_MasterData_Ex::clearCache("mtb_customer_order_status");

				$arrData = array(
				"payment_method" => "後払い決済(ASJペイメント)"	//支払方法
				,"fix" => 3						//
				,"creator_id" => $this->objSess->member_id		//顧客ID
				,"create_date" => "now()"				//作成日
				,"update_date" => "now()"				//更新日
				,"charge_flg" => 1					//手数料使用フラグ
				,"charge" => 0						//手数料
				,"upper_rule" => 1000000			//決済の上限金額
				,"rule_max" => 100					//決済の下限金額
				,"module_code" => $this->module_name			//モジュール名
				,"module_path" => MODULE_REALDIR . "mdl_asjpayment/credit.php"//モジュールの処理を読み込む
				,"memo01" => $_POST["credit_ip"]			//
				,"memo02" => $_POST["credit_url"]			//
				,"memo03" => $val
				,"memo04" => "57"					//
				,"memo05" => $_POST["credit_login"]			//ログインID
				,"memo06" => $_POST["credit_pass"]			//パスワード
				,"memo07" => $_POST["credit_link_url"]			//同期URL
				,"memo08" => $_POST["regular_csv_url"]			//定期購入CSVURL
				,"memo09" => $_POST["regular_edit_url"]			//定期購入変更URL
				,"memo10" => $_POST["after_stock"]			//在庫管理
				,"del_flg" => "0"
				,"upper_rule_max" => CHARGE_MAX
				);
				break;
			default:
				break;
			}
			// 支払方法データを取得
			$arrPayment = $this->lfgetPaymentDB($val);
			// 支払方法データが存在すればUPDATE
			if (count($arrPayment) > 0) {
				$this->objQuery->update("dtb_payment", $arrData, "module_code = ? AND memo03 = ?", array($this->module_name, $val));
				// 支払方法データが無ければINSERT
			 } else {
				// ランクの最大値を取得
				$max_rank = $this->objQuery->getone("SELECT max(rank) FROM dtb_payment");
				$arrData["rank"] = $max_rank + 1;
				$max_id = $this->objQuery->getone("SELECT max(payment_id) FROM dtb_payment");
				$arrData["payment_id"] = $max_id + 1;
				$this->objQuery->insert("dtb_payment", $arrData);
			}
		}
	}

	/**
	* テーブルを更新
	*/
	function updateTable(){
		$objDB = new SC_Helper_DB_Ex();
		$ret = $objDB->sfColumnExists(
			'dtb_payment', 'module_code', 'text', "", $add = false
		);
		if($ret == false) {
			$objASJDB = new LC_Query_Asjpayment();
			$objASJDB->query("ALTER TABLE dtb_payment ADD module_code text");
		}
	}

	/**
	* ファイルを更新
	*/
	function updateFile(){
		foreach ($this->arrUpdateFile as $array) {
			$dst_file = $array['dst'];
			$src_file = $array['src'];
			// ファイルがない、またはファイルはあるが異なる場合
			if(!file_exists($dst_file) || sha1_file($src_file) != sha1_file($dst_file)) {
				if(is_writable($dst_file) || is_writable(dirname($dst_file))) {
					copy($src_file, $dst_file);
				} else {
					return false;
				}
			}
		}
		return true;
	}

	// ポスト要求処理
	function sendPost($url, $arrPost) {
		$req = new HTTP_Request($url);
		$req->setMethod(HTTP_REQUEST_METHOD_POST);
		// 電文の送付
		$req->addPostDataArray($arrPost);
		// 応答内容の取得
		$response = $req->sendRequest();
		$err_flg = false;
		if (!PEAR::isError($response)) {
			$response = $req->getResponseBody();
		} else {
			$mess = mb_convert_encoding($e->getMessage(), CHAR_CODE, "SJIS");
			$err_flg = true;
		}
		$req->clearPostData();
		if (!$err_flg) {
			$response = mb_convert_encoding($response, CHAR_CODE, "SJIS");
			$response = split("\n", $response);
			return $response;
		} else {
			return $mess;
		}
	}

}
