<?php
// {{{ requires
require_once(realpath(dirname( __FILE__)). '/LC_Page_Mdl_Asjpayment_Config.php');
if(ECCUBE_VERSION == '2.11.0' || ECCUBE_VERSION == '2.11.1' || ECCUBE_VERSION == '2.11.2') {
	require_once(DATA_REALDIR. 'module/Request.php');
} else {
	require_once(DATA_REALDIR. 'module/HTTP/Request.php');
}

/*debug_start*/
require_once(CLASS_REALDIR . "util/SC_Utils.php");
/*debug_end*/


class LC_Page_Mdl_Asjpayment_Credit extends LC_Page_Ex {
	var $objConfig;
	var $arrConfig;
	var $objFormParam;
	var $objQuery;
	var $arrPaymentClass;
	var $objHelperDB;
	var $subData;		/* サブデータを保持する変数 */
	var $moduleInfo;	/* モジュール情報 */
	/**
	 * コンストラクタ
	 *
	 * @return void
	 */
	function LC_Page_Mdl_Asjpayment_Credit() {
		$this->objQuery = new SC_Query();
		$this->objConfig = new LC_Page_Mdl_Asjpayment_Config();
		$this->arrConfig = $this->objConfig->getConfig();
		//$this->objHelperDB = new SC_Helper_DB();
		$this->objFormParam = new SC_FormParam_Ex();

		$subData = "";
		$moduleInfo = array('moduleCode' => MDL_ASJPAYMENT_CODE);
	}

	/**
	 * Page を初期化する.
	 *
	 * @return void
	 */
	function init() {
		parent::init();
		session_cache_limiter('private-no-expire');
	}

	 /**
	 * Page のプロセス.
	 *
	 * @return void
	 */
	function process() {
		parent::process();
		$this->action();
		$this->sendResponse();
	}

	/**
	 * Page のアクション.
	 *
	 * @return void
	 */
	function action() {
		$objCartSess = new SC_CartSession_Ex();
		$objSiteSess = new SC_SiteSession_Ex();
		$objCustomer = new SC_Customer_Ex();
		$objQuery = new SC_Query_Ex();
		$objDb = new SC_Helper_DB_Ex();
		$objPurchase = new SC_Helper_Purchase_Ex();
		$cart_key = $objCartSess->getKey();

		// ユーザユニークIDの取得と購入状態の正当性をチェック
		$this->tpl_uniqid = $objSiteSess->getUniqId();
		// 注文情報を取得
		$arrData = $objPurchase->getOrder($_SESSION['order_id']);
		// 注文情報詳細を取得
		$arrDataDetail = $objPurchase->getOrderDetail($_SESSION['order_id']);
		/* サブデータ取得 */
		$arrConfig = $this->getSubData();
		if($arrConfig['reg']['reg_product_type'] == $cart_key) {
			if(!SC_Utils_Ex::isBlank($_SESSION['order_id'])) {
				// 受注データへのフラグ付
				$order_id = $_SESSION['order_id'];
				$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_SPFLG] = MDL_ASJPAYMENT_SPFLG_STR;
				$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_SPDATA] = '';	// この時点では空
				$objQuery->begin();
				$objPurchase->sfUpdateOrderStatus($order_id, null, null, null, $sqlval);
				$objQuery->commit();
			}
//			if(SC_Utils_Ex::isBlank($arrData[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG])) {
//			} else {
//			}
			$arrData = array_merge($arrData, array("regular" => "1"));
			if(!SC_Utils_Ex::isBlank($arrConfig['reg']['reg_order_min_day'])) {
				$arrData = array_merge($arrData, array("min_day" => $arrConfig['reg']['reg_order_min_day']));
			} else {
				$arrData = array_merge($arrData, array("min_day" => "0"));
			}

		}

		// 支払い情報を取得
		$arrPayment = $this->objQuery->getall("SELECT module_id, memo01, memo02, memo03, memo04, memo05, memo06, memo07, memo08, memo09, memo10 FROM dtb_payment WHERE payment_id = ? ", array($arrData["payment_id"]));
		// 配送先を取得
		$arrShipping = $this->objQuery->getall("SELECT shipping_name01, shipping_name02, shipping_zip01, shipping_zip02, shipping_pref, shipping_addr01, shipping_addr02, shipping_tel01, shipping_tel02, shipping_tel03 FROM dtb_shipping WHERE order_id = ? ", array($_SESSION['order_id']));		// POST値の取得
		$this->objFormParam->setParam($_POST);
		// コンビニ・銀行決済の場合ステータス変更
		if($arrPayment[0]["memo03"] - 50 == 2) {
			$objPurchase->sfUpdateOrderStatus($arrData["order_id"], ORDER_PAY_WAIT);
		}
		// 携帯端末の場合は、セッションID・オーダー番号・戻ってくるURLを保存しておく。
		if (is_callable("SC_MobileUserAgent", "isMobile") && SC_MobileUserAgent::isMobile()) {
			if($arrPayment[0]["memo03"] - 50 == 2) {
				$this->lfDispComplete($arrData, $arrPayment, $arrVal["memo02"]);
			} else {
				$this->lfSendCredit($arrData, $arrDataDetail, $arrShipping, $arrPayment, $arrVal["memo02"]);
			}
		}else{
			if($arrPayment[0]["memo03"] - 50 == 2) {
				$this->lfDispComplete($arrData, $arrPayment, $arrVal["memo02"]);
			} else {
				$this->lfSendPcCredit($arrData, $arrDataDetail, $arrShipping, $arrPayment, $arrVal["memo02"]);
			}
		}
	}

	/**
	 * 決済データを送信する
	 *
	 * @param unknown_type $arrData
	 * @param unknown_type $arrPayment
	 * @param unknown_type $arrMainProduct
	 * @param unknown_type $again
	 */
	function lfSendCredit($arrData, $arrDataDetail, $arrShipping, $arrPayment, $arrMainProduct, $again = true){
		//$this->objCampaignSess = new SC_CampaignSession();
		$this->objSiteSess = new SC_SiteSession();
		$this->objCustomer = new SC_Customer();

		$arrSendData = array(
		'admin' => $arrPayment[0]["memo01"],									// 契約者番号
		'charge' => $arrData["order_id"],									// オーダー番号
		'amount' => $arrData["payment_total"],									// 決済金額
		'mail' => $arrData["order_email"],									// メールアドレス
		'name' => htmlspecialchars($arrData["order_name01"]."　".$arrData["order_name02"], ENT_QUOTES),	// 名前
		'charge_type' => $arrPayment[0]["memo03"] - 50,								// 支払方法
		'mobile' => "1",											// 携帯
		'PHPSESSID' => session_id(),										//
		);
		// 定期購入
		if(isset($arrData["regular"]) && $arrData["regular"] == 1) {
			$arrSendData = array_merge($arrSendData, array("regular" => "1"));
			$arrSendData = array_merge($arrSendData, array("regular_kind" => MDL_ASJPAYMENT_REGULAR_KIND_MONTH));
			$arrSendData = array_merge($arrSendData, array("min_day" => $arrData["min_day"]));
			$arrSendData = array_merge($arrSendData, array("regular_amount" => $arrData["total"]));
		}
		// 後払い.com　アトディーネ
		if($arrPayment[0]["memo03"] - 50 == 4 || $arrPayment[0]["memo03"] - 50 == 7) {
			$arrSendData += array(
				'zip1' => $arrData["order_zip01"],
				'zip2' => $arrData["order_zip02"],
				'state' => $arrData["order_pref"],
				'city' => htmlspecialchars($arrData["order_addr01"], ENT_QUOTES),
				'street' => htmlspecialchars($arrData["order_addr02"], ENT_QUOTES),
				'tel' => $arrData["order_tel01"]."-".$arrData["order_tel02"]."-".$arrData["order_tel03"],
			);
			$arrSendData += array(
				'ship_name' => htmlspecialchars($arrShipping[0]["shipping_name01"]."　".$arrShipping[0]["shipping_name02"], ENT_QUOTES),
				'ship_zip1' => $arrShipping[0]["shipping_zip01"],
				'ship_zip2' => $arrShipping[0]["shipping_zip02"],
				'ship_state' => $arrShipping[0]["shipping_pref"],
				'ship_city' => htmlspecialchars($arrShipping[0]["shipping_addr01"], ENT_QUOTES),
				'ship_street' => htmlspecialchars($arrShipping[0]["shipping_addr02"], ENT_QUOTES),
				'ship_tel' => $arrShipping[0]["shipping_tel01"]."-".$arrShipping[0]["shipping_tel02"]."-".$arrShipping[0]["shipping_tel03"],
			);
			$in_item_price_total = 0;
			$i = 1;
			foreach ($arrDataDetail as $detail) {
				$arrSendData += array(
					'item'.$i => htmlspecialchars($detail["product_name"], ENT_QUOTES),
					'price'.$i => SC_Helper_TaxRule::sfCalcIncTax($detail["price"], $detail["tax_rate"], $detail["tax_rule"]),
					'count'.$i => $detail["quantity"],
				);
				$in_item_price_total += SC_Helper_TaxRule::sfCalcIncTax($detail["price"], $detail["tax_rate"], $detail["tax_rule"]) * $detail["quantity"];
				$i++;
			}
			//以下、明細に必要なパラメータ（送料、ポイント、手数料）
			if($arrData["deliv_fee"] > 0) {
				$arrSendData += array(
					'item'.$i => "送料",
					'price'.$i => $arrData["deliv_fee"],
					'count'.$i => "1",
				);
				$i++;
			}
			if($arrData["use_point"] > 0) {
				$arrSendData += array(
					'item'.$i => "使用ポイント",
					'price'.$i => 0 - $arrData["use_point"],
					'count'.$i => "1",
				);
				$i++;
			}
			if($arrData["charge"] > 0) {
				$arrSendData += array(
					'item'.$i => "手数料",
					'price'.$i => $arrData["charge"],
					'count'.$i => "1",
				);
				$i++;
			}
			/* プラグインなどによるクーポン等の割引により合計金額が一致しなくなる場合の対応 */
			$in_adjustment = $in_item_price_total - ($arrData["payment_total"] - $arrData["deliv_fee"] + $arrData["use_point"] - $arrData["charge"]);
			if($in_adjustment > 0) {
				$arrSendData += array(
					'item'.$i => "割引",
					'price'.$i => 0 - $in_adjustment,
					'count'.$i => "1",
				);
				$i++;
			}
		}
		/* カード決済情報を保持使用	*/
		$arrConfig = $this->getSubData();
		$str_key = "";
		$str_user = "";
		$str_time = "";
		if($arrPayment[0]["memo03"] - 50 == 1
		&& array_key_exists("card_retention", $arrConfig) === true && strcmp($arrConfig["card_retention"], "1") == 0
		&& array_key_exists("card_retention_pass", $arrConfig) && !SC_Utils_Ex::isBlank($arrConfig['card_retention_pass'])
		&& array_key_exists("customer_id", $arrData) && !SC_Utils_Ex::isBlank($arrData['customer_id'] && (int)$arrData['customer_id'] > 0)
		) {
			$str_tmp = "";
			$str_tmp .= sprintf("admin=%d", $arrPayment[0]["memo01"]);
			$str_tmp .= sprintf("&amount=%d", $arrData["payment_total"]);
			$str_tmp .= sprintf("&charge=%d", $arrData["order_id"]);
			$str_tmp .= sprintf("&user=%d", $arrData['customer_id']);
			$str_tmp .= sprintf("&time=%d", time());
			$str_tmp .= sprintf("&%s", $arrConfig['card_retention_pass']);
			$str_key = hash("sha256", $str_tmp);
			$str_user = sprintf("%d", $arrData['customer_id']);
			$str_time = sprintf("%d", time());
		}
		$html = "<html>\n";
		$html .= "<head>\n";
		$html .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n";
		$html .= "<title>ASJ Payment</title>\n";
		$html .= "</head>\n";
		$html .= "<body>\n";
		$html .= "\t<form name=\"form1\" id=\"form1\" method=\"post\" action=\"" . $arrPayment[0]["memo02"] . "\">\n";
		foreach($arrSendData as $key => $val){
			//$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".mb_convert_encoding($val,"SJIS","UTF-8")."\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".$val."\">\n";
		}
		if($str_key !== "") {
			$html .= "\t\t<input type=\"hidden\" name=\"user\" value=\"" . $str_user . "\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"time\" value=\"" . $str_time . "\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"key\" value=\"" . $str_key . "\">\n";
		}
		$html .= "\t\t<input type=\"hidden\" name=\"version\" value=\"" . ECCUBE_VERSION . "_" . MDL_ASJPAYMENT_VERSION . "\">\n";
		$html .= "\t\t<center>ここからASJペイメントの決済ページに移動します。<br>決済方法を変更される方は<a href=\"payment.php\">こちら</a>からお戻り下さい。<br><br>\n";
		$html .= "\t\t<center><input type=\"submit\" value=\"クレジット決済を開始する\"></center>\n";
		// 正常な推移であることを記録しておく
		$this->objSiteSess->setRegistFlag();

		// 携帯端末の場合は、セッションID・オーダー番号・戻ってくるURLを保存しておく。
		if (is_callable("SC_MobileUserAgent", "isMobile") && SC_MobileUserAgent::isMobile()) {
			SC_Helper_Mobile::sfMobileSetExtSessionId('order_number', $arrData['order_id'], 'mobile/userdata/asjpayment_recv.php');
		}
		$html .= "\t</form>\n";
		$html .= "</body>\n";
		$html .= "</html>\n";
		echo $html;
		exit();

		$url = $html;
		header("Location: " . $url);
	}

	// データ送信処理(PC)
	function lfSendPcCredit($arrData, $arrDataDetail, $arrShipping, $arrPayment, $order_url){
		//$this->objCampaignSess = new SC_CampaignSession();
		$this->objSiteSess = new SC_SiteSession();
		//global $objCartSess;
		$objCartSess = new SC_CartSession_Ex();
		global $objSiteSess;
		global $objDb;
		global $arrInfo;

		// カート内情報の取得
		$arrCart = $objCartSess->getCartList($objCartSess->getKey());

		$arrSendData = array(
		'admin' => $arrPayment[0]["memo01"],								// 契約者番号
		'charge' => $arrData["order_id"],								// オーダー番号
		'amount' => $arrData["payment_total"],								// 決済金額
		'mail' => $arrData["order_email"],								// メールアドレス
		'name' => htmlspecialchars($arrData["order_name01"]."　".$arrData["order_name02"], ENT_QUOTES),	// 名前
		'charge_type' => $arrPayment[0]["memo03"] - 50,							// 支払方法
		);

		// 定期購入
		if(isset($arrData["regular"]) && $arrData["regular"] == 1) {
			$arrSendData = array_merge($arrSendData, array("regular" => "1"));
			$arrSendData = array_merge($arrSendData, array("regular_kind" => MDL_ASJPAYMENT_REGULAR_KIND_MONTH));
			$arrSendData = array_merge($arrSendData, array("min_day" => $arrData["min_day"]));
			$arrSendData = array_merge($arrSendData, array("regular_amount" => $arrData["total"]));
		}
		//アトディーネ
		if($arrPayment[0]["memo03"] - 50 == 4 || $arrPayment[0]["memo03"] - 50 == 7) {
			$arrSendData += array(
				'zip1' => $arrData["order_zip01"],
				'zip2' => $arrData["order_zip02"],
				'state' => $arrData["order_pref"],
				'city' => htmlspecialchars($arrData["order_addr01"], ENT_QUOTES),
				'street' => htmlspecialchars($arrData["order_addr02"], ENT_QUOTES),
				'tel' => $arrData["order_tel01"].$arrData["order_tel02"].$arrData["order_tel03"],
			);
			$arrSendData += array(
				'ship_name' => htmlspecialchars($arrShipping[0]["shipping_name01"]."　".$arrShipping[0]["shipping_name02"], ENT_QUOTES),
				'ship_zip1' => $arrShipping[0]["shipping_zip01"],
				'ship_zip2' => $arrShipping[0]["shipping_zip02"],
				'ship_state' => $arrShipping[0]["shipping_pref"],
				'ship_city' => htmlspecialchars($arrShipping[0]["shipping_addr01"], ENT_QUOTES),
				'ship_street' => htmlspecialchars($arrShipping[0]["shipping_addr02"], ENT_QUOTES),
				'ship_tel' => $arrShipping[0]["shipping_tel01"].$arrShipping[0]["shipping_tel02"].$arrShipping[0]["shipping_tel03"],
			);
			$in_item_price_total = 0;
			$i = 1;
			foreach ($arrDataDetail as $detail) {
				$arrSendData += array(
					'item'.$i => htmlspecialchars($detail["product_name"], ENT_QUOTES),
					'price'.$i => SC_Helper_TaxRule::sfCalcIncTax($detail["price"], $detail["tax_rate"], $detail["tax_rule"]),
					'count'.$i => $detail["quantity"],
				);
				$in_item_price_total += SC_Helper_TaxRule::sfCalcIncTax($detail["price"], $detail["tax_rate"], $detail["tax_rule"]) * $detail["quantity"];
				$i++;
			}
			//以下、明細に必要なパラメータ（送料、ポイント、手数料）
			if($arrData["deliv_fee"] > 0) {
				$arrSendData += array(
					'item'.$i => "送料",
					'price'.$i => $arrData["deliv_fee"],
					'count'.$i => "1",
				);
				$i++;
			}
			if($arrData["use_point"] > 0) {
				$arrSendData += array(
					'item'.$i => "使用ポイント",
					'price'.$i => 0 - $arrData["use_point"],
					'count'.$i => "1",
				);
				$i++;
			}
			if($arrData["charge"] > 0) {
				$arrSendData += array(
					'item'.$i => "手数料",
					'price'.$i => $arrData["charge"],
					'count'.$i => "1",
				);
				$i++;
			}
			/* プラグインなどによるクーポン等の割引により合計金額が一致しなくなる場合の対応 */
			$in_adjustment = $in_item_price_total - ($arrData["payment_total"] - $arrData["deliv_fee"] + $arrData["use_point"] - $arrData["charge"]);
			if($in_adjustment > 0) {
				$arrSendData += array(
					'item'.$i => "割引",
					'price'.$i => 0 - $in_adjustment,
					'count'.$i => "1",
				);
				$i++;
			}
		}
		if($arrPayment[0]["memo10"]) {
			$objQuery = SC_Query_Ex::getSingletonInstance();
			$arrOrderMemo = $objQuery->getall("SELECT T1.memo10 FROM dtb_order T1 WHERE T1.order_id = ? ", $arrData["order_id"]);
			if($arrOrderMemo[0]["memo10"] && $arrOrderMemo[0]["memo10"] == '1') {
				/* 二重呼び出しにより更新済 */
			} else {
				foreach ($arrDataDetail as $arrDetail) {
					$objQuery->update('dtb_products_class', array(),
						'product_class_id = ?', array($arrDetail['product_class_id']),
						array('stock' => 'stock + ?'), array($arrDetail['quantity']));
				}
				/* 呼び出し済の値を登録 */
				$objQuery->update('dtb_order', array(),
						'order_id = ?', array($arrData["order_id"]),
						array('memo10' => '?'), array('1'));
			}
		}
		// Chrome時特別処理
		$useragent = $_SERVER['HTTP_USER_AGENT'];
		if(strpos($useragent, 'Chrome/') !== false && strpos($useragent, 'Edge/') === false) {
			// セッションクッキーの設定をみて置き換えるかどうか
			$cookieopt = session_get_cookie_params();
			$re_cookie = true;
			if(strtolower($cookieopt['samesite']) === 'none' && $cookieopt['secure'] === true) {
				$re_cookie = false;
			}
			// セッションがクッキーとして発行されていたならセッションの設定を変更して再開する
			if($re_cookie === true && array_key_exists(session_name(), $_COOKIE)) {
				session_write_close();
				session_set_cookie_params($cookieopt["lifetime"], $cookieopt["path"]."; SameSite=None", $cookieopt["domain"], true, $cookieopt["httponly"]);
				session_start();
			}
		}
		/* カード決済情報を保持使用	*/
		$arrConfig = $this->getSubData();
		$str_key = "";
		$str_user = "";
		$str_time = "";
		if($arrPayment[0]["memo03"] - 50 == 1
		&& array_key_exists("card_retention", $arrConfig) === true && strcmp($arrConfig["card_retention"], "1") == 0
		&& array_key_exists("card_retention_pass", $arrConfig) && !SC_Utils_Ex::isBlank($arrConfig['card_retention_pass'])
		&& array_key_exists("customer_id", $arrData) && !SC_Utils_Ex::isBlank($arrData['customer_id'] && (int)$arrData['customer_id'] > 0)
		) {
			$str_tmp = "";
			$str_tmp .= sprintf("admin=%d", $arrPayment[0]["memo01"]);
			$str_tmp .= sprintf("&amount=%d", $arrData["payment_total"]);
			$str_tmp .= sprintf("&charge=%d", $arrData["order_id"]);
			$str_tmp .= sprintf("&user=%d", $arrData['customer_id']);
			$str_tmp .= sprintf("&time=%d", time());
			$str_tmp .= sprintf("&%s", $arrConfig['card_retention_pass']);
			$str_key = hash("sha256", $str_tmp);
			$str_user = sprintf("%d", $arrData['customer_id']);
			$str_time = sprintf("%d", time());
		}
		$html = "<html>\n";
		$html .= "<head>\n";
		$html .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n";
		$html .= "<title>ASJ Payment</title>\n";
		$html .= "</head>\n";
		$html .= "<body onload=\"document.form1.submit();\">\n";
		$html .= "\t<form name=\"form1\" id=\"form1\" method=\"post\" action=\"" . $arrPayment[0]["memo02"] . "\">\n";
		foreach($arrSendData as $key => $val){
			//$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".mb_convert_encoding($val,"EUC-JP","UTF-8")."\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".mb_convert_encoding($val,"EUC-JP","ASCII,JIS,UTF-8,EUC-JP,SJIS")."\">\n";
			//$html .= "\t\t<input type=\"hidden\" name=\"".$key."\" value=\"".$val."\">\n";
		}
		if($str_key !== "") {
			$html .= "\t\t<input type=\"hidden\" name=\"user\" value=\"" . $str_user . "\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"time\" value=\"" . $str_time . "\">\n";
			$html .= "\t\t<input type=\"hidden\" name=\"key\" value=\"" . $str_key . "\">\n";
		}
		$html .= "\t\t<input type=\"hidden\" name=\"version\" value=\"" . ECCUBE_VERSION .  "_". MDL_ASJPAYMENT_VERSION . "\">\n";
		//ini_set("mbstring.http_output", "pass");
		mb_http_output('EUC-JP');
		header("Content-Type: text/html; charset=euc-jp");

		// 正常な推移であることを記録しておく
		//$this->objSiteSess->setRegistFlag();

		// 携帯端末の場合は、セッションID・オーダー番号・戻ってくるURLを保存しておく。
		if (is_callable("SC_MobileUserAgent", "isMobile") && SC_MobileUserAgent::isMobile()) {
			SC_Helper_Mobile::sfMobileSetExtSessionId('order_number', $arrData['order_id'], 'mobile/shopping/load_payment_module.php');
			SC_Helper_Mobile::sfMobileSetExtSessionId('order_number', $arrData['order_id'], 'mobile/shopping/confirm.php');
		}

		$html .= "\t</form>\n";
		$html .= "</body>\n";
		$html .= "</html>\n";
		echo $html;
		exit();

		$url = $html;
		header("Location: " . $url);
	}

	/**
	 * サブデータを取得する.
	 *
	 * @return mixed|null
	 */
	function getSubData($key = null) {
		if(isset($this->subData)) {
			if(is_null($key)) {
				return $this->subData;
			} else {
				return $this->subData[$key];
			}
		}
		$objQuery =& SC_Query::getSingletonInstance();
		$ret = $objQuery->get('sub_data', 'dtb_module', 'module_code =?', MDL_ASJPAYMENT_CODE);
		if(isset($ret)) {
			$this->subData = unserialize($ret);
			if(is_null($key)) {
				return $this->subData;
			} else {
				return $this->subData[$key];
			}
		}
		return null;
	}

	// 完了画面
	function lfDispComplete($arrData, $arrPayment, $order_url){
		$objQuery = new SC_Query();
		$objMail = new SC_Helper_Mail();

		$objSiteInfo = $objView->objSiteInfo;
		$arrInfo = $objSiteInfo->data;
		$objPurchase = new SC_Helper_Purchase();
		$objResponse = new SC_Response_Ex();

		$count = $objQuery->count("dtb_mail_history", "order_id = ?", $arrData['order_id']);
		if($count == 0) {
			$objMail->sfSendOrderMail($arrData['order_id'], '1');
		}
		// ページを表示
		$objResponse->sendRedirect(SHOPPING_COMPLETE_URLPATH);
	}
}
