<?php

require_once(MODULE_REALDIR . "mdl_asjpayment/LC_Page_Mdl_Asjpayment_Config.php");
require_once(MODULE_REALDIR . "mdl_asjpayment/include.php");
require_once(MODULE_REALDIR . "mdl_asjpayment/LC_Page_Mdl_Asjpayment_Csv_Ex.php");
require_once(CLASS_EX_REALDIR . 'page_extends/admin/LC_Page_Admin_Ex.php');

/**
 * Description of LC_Page_Mdl_Asjpayment_Csv
 */
class LC_Page_Mdl_Asjpayment_Csv extends LC_Page_Admin_Ex {
	var $arrErr;
	var $objConfig;

	/**
	 * コンストラクタ.
	 */
	function LC_Page_Mdl_Asjpayment_Csv() {
		$this->module_title = "ＡＳＪペイメント決済モジュール";
		$this->objConfig = new LC_Page_Mdl_Asjpayment_Config();
		$this->arrConfig = $this->objConfig->getConfig();
		$this->objFormParam = new SC_FormParam_Ex();
	}

	/**
	 * Page を初期化する.
	 */
	function init() {
		parent::init();

		$this->tpl_mainpage = MODULE_REALDIR . $this->objConfig->module_name . "/asjpayment_csv.tpl";
		$this->tpl_subtitle = $this->module_title;
		global $arrJob;
		$this->arrJob = $arrJob;
		$this->arrErr = array();
	}

	/**
	 * Page のプロセス.
	 */
	function process() {
		$objQuery = new SC_Query();
		$objView = new SC_SiteView();
		$this->objFormParam = new SC_FormParam_Ex();

		// パラメータ情報の初期化
		$this->lfInitParam();
		// 支払情報を取得
		$this->arrPayment = $this->objConfig->lfgetPaymentDB(51);
		// 注文番号を取得
		// 拡張セット送信内容設定
		$this->arrSendData = array(
			'version'=> MDL_ASJPAYMENT_VERSION								// 決済モジュールバージョン番号
			, 'admin'			=> $this->arrPayment[0]["memo01"]			// 契約者番号
			, 'login'			=> $this->arrPayment[0]["memo05"]			// ログインID
			, 'pass'			=> $this->arrPayment[0]["memo06"]			// パスワード
			, 'send_url'		=> $this->arrPayment[0]["memo07"]			// CSV登録URL
			, 'return'		=> HTTP_URL . ADMIN_DIR . 'order/asjpayment_csv.php'	// 完了通知URL
			, 'ng_return'	=> HTTP_URL . ADMIN_DIR . 'order/asjpayment_csv.php'	// NG完了通知URL
			);

		if(empty($this->arrPayment[0]['memo07'])) {
			$this->arrErr['sendurl'] = '同期URLを登録してください。<br>';
			$this->tpl_error_commit = implode("\n", $this->arrErr);
		}
		// ボタン制御
		$this->btnControl($arrOrder[0]);

		$this->arrForm = $this->objFormParam->getFormParamList();
		$objView->assignobj($this);
		$objView->display($this->tpl_mainpage);
	}

	/**
	 * デストラクタ.
	 */
	function destroy() {
		parent::destroy();
	}

	/**
	 * 初期化処理.
	 */
	function lfInitParam() {
		// パラメータ情報の初期化
		$this->objFormParam->addParam("処理区分", "memo02");
		$this->objFormParam->addParam("請求金額", "payment_total");
		$this->objFormParam->addParam("実売上", "btnSales");
		$this->objFormParam->addParam("即日取消", "btnVoid");
		$this->objFormParam->addParam("返品", "btnReturn");
	}

	/**
	 * ボタン制御処理.
	 */
	function btnControl($arrData) {
		// エラーありの場合
		if(count($this->arrErr) != 0) {
			$btnSales = "disabled";
			$btnVoid = "disabled";
			$btnReturn = "disabled";
		// エラーなしの場合
		} else {
			switch($arrData['memo02']) {
			case ASJPAYMENT_STATUS_SALES:	// 売上
				break;
			case ASJPAYMENT_STATUS_SEND:	// 実売上
			case ASJPAYMENT_STATUS_CANCEL:	// 取消
			default:
				$btnSend = "disabled";
				$btnCancel = "disabled";
				break;
			}
		}
		$this->objFormParam->setValue("btnSend", $btnSend);
		$this->objFormParam->setValue("btnCencel", $btnCancel);
	}
}
