<?php

require_once(MODULE_REALDIR . "mdl_asjpayment/LC_Page_Mdl_Asjpayment_Config.php");
require_once(MODULE_REALDIR . "mdl_asjpayment/include.php");
require_once(MODULE_REALDIR . "mdl_asjpayment/LC_Page_Mdl_Asjpayment_Edit_Ex.php");
require_once(CLASS_EX_REALDIR . 'page_extends/admin/LC_Page_Admin_Ex.php');

/**
 * Description of LC_Page_Mdl_Asjpayment_Edit
 */
class LC_Page_Mdl_Asjpayment_Edit extends LC_Page_Admin_Ex {
	var $arrErr;
	var $objConfig;

	/**
	 * コンストラクタ.
	 */
	function LC_Page_Mdl_Asjpayment_Edit() {
		$this->module_title = "ＡＳＪペイメント決済モジュール";
		$this->objConfig = new LC_Page_Mdl_Asjpayment_Config();
		$this->arrConfig = $this->objConfig->getConfig();
		$this->objFormParam = new SC_FormParam_Ex();
	}

	/**
	 * Page を初期化する.
	 */
	function init() {
		parent::init();
		$this->tpl_mainpage = MODULE_REALDIR . $this->objConfig->module_name . "/asjpayment_edit.tpl";
		$this->tpl_movepage = MODULE_REALDIR . $this->objConfig->module_name . "/asjpayment_edit_move.tpl";
		$this->tpl_subtitle = $this->module_title;
		global $arrJob;
		$this->arrJob = $arrJob;
		$this->arrErr = array();
		$objDate = new SC_Date_Ex(DATE("Y") - 1);
		$objDate->setEndYear(DATE("Y") + 1);
		$this->arrYearShippingDate = $objDate->getYear();
		$this->arrMonthShippingDate = $objDate->getMonth(true);
		$this->arrDayShippingDate = $objDate->getDay(true);
	}

	/**
	 * Page のプロセス.
	 */
	function process() {
		$objQuery = new SC_Query();
		$objView = new SC_SiteView();
		$this->objFormParam = new SC_FormParam_Ex();
		// パラメータ情報の初期化
		$this->lfInitParam();
		// 支払情報を取得
		$this->arrPayment = $this->objConfig->lfgetPaymentDB(51);
		// 注文番号を取得
		if(isset($_POST['send'])
		|| isset($_POST['cancel'])) {
			$this->order_id = $_POST['order_id'];
		} else {
			$this->order_id = $_GET['order_id'];
		}
		$bMove = false;
		$col = "payment_date";
		$arrOrder = $objQuery->select($col, "dtb_order", "order_id = ?", array($this->order_id));
		if(SC_Utils_Ex::isBlank($arrOrder[0]['payment_date'])) {
			$this->arrErr['sendurl'] = 'この注文は入金日が登録されていないため、<br>処理することができません。<br>';
			$this->tpl_error_commit = implode("\n", $this->arrErr);
		} else if(empty($this->arrPayment[0]['memo07'])) {
			$this->arrErr['sendurl'] = '同期URLを登録してください。<br>';
			$this->tpl_error_commit = implode("\n", $this->arrErr);
		} else {
			//取消
			if(isset($_POST['cancel'])) {
				$bMove = true;
			//実売上
			} else if(isset($_POST['send'])) {
				$this->objFormParam->setValue('shipping_date_year', $_POST['shipping_date_year']);
				$this->objFormParam->setValue('shipping_date_month', $_POST['shipping_date_month']);
				$this->objFormParam->setValue('shipping_date_day', $_POST['shipping_date_day']);
				$this->arrErr = $this->lfCheckError($this->objFormParam);
				if(!SC_Utils_Ex::isBlank($this->arrErr)) {
					$this->tpl_error_commit = implode("\n", $this->arrErr);
				} else {
					/* 決済確定日 現在時間 で登録 */
					$sqlval['commit_date'] = sprintf("%04d/%02d/%02d %s"
														, $_POST['shipping_date_year']
														, $_POST['shipping_date_month']
														, $_POST['shipping_date_day'], date("H:i:s"));
					$dateTimePayment = new DateTime($arrOrder[0]['payment_date']);
					$dateTimeComplete = new DateTime($sqlval['commit_date']);
					if(strtotime($dateTimePayment->format('Y-m-d H:i:s')) > strtotime($dateTimeComplete->format('Y-m-d H:i:s'))) {
						$this->arrErr['shipping_date_year'] = '決済確定日は、入金日以降の日付を入力してください。<br>';
						$this->arrErr['shipping_date_month'] = ' ';
						$this->arrErr['shipping_date_day'] = ' ';
						$this->tpl_error_commit = implode("\n", $this->arrErr);
					} else {
						$sqlval['status'] = ORDER_DELIV;
						$where = 'order_id = ?';
						// 受注テーブル更新
						$objQuery->update('dtb_order', $sqlval, $where, array($this->order_id));
						$bMove = true;
					}
				}
			}
		}
		// 受注情報を取得
		$col = "order_id, payment_total, create_date, memo02";
		$arrOrder = $objQuery->select($col, "dtb_order", "order_id = ?", array($this->order_id));
		$this->objFormParam->setParam($arrOrder[0]);
		$this->arrForm = $arrOrder[0];
		// 拡張セット送信内容設定
		$this->arrSendData = lfCreateEditSetSendData($arrOrder[0], $this->arrPayment);
		if($bMove == true) {
			if(isset($_POST['cancel'])) {
				$this->arrSendData['opt'] = '2';
			} else if(isset($_POST['send'])) {
				$this->arrSendData['opt'] = '1';
				$this->arrSendData['shipping_date_year'] = $_POST['shipping_date_year'];
				$this->arrSendData['shipping_date_month'] = $_POST['shipping_date_month'];
				$this->arrSendData['shipping_date_day'] = $_POST['shipping_date_day'];
			}
		}
		$this->arrForm = $this->objFormParam->getFormParamList();
		$objView->assignobj($this);
		if($bMove == true) {
			$objView->display($this->tpl_movepage);
		} else {
			$objView->display($this->tpl_mainpage);
		}
	}

	/**
	 * デストラクタ.
	 */
	function destroy() {
		parent::destroy();
	}

	/**
	 * 初期化処理.
	 */
	function lfInitParam() {
		// パラメータ情報の初期化
		$this->objFormParam->addParam('請求金額', 'payment_total');
		$this->objFormParam->addParam('決済確定日：年', 'shipping_date_year', INT_LEN, 'n', array('EXIST_CHECK', 'MAX_LENGTH_CHECK', 'NUM_CHECK'));
		$this->objFormParam->addParam('決済確定日：月', 'shipping_date_month', INT_LEN, 'n', array('EXIST_CHECK', 'MAX_LENGTH_CHECK', 'NUM_CHECK'));
		$this->objFormParam->addParam('決済確定日：日', 'shipping_date_day', INT_LEN, 'n', array('EXIST_CHECK', 'MAX_LENGTH_CHECK', 'NUM_CHECK'));
	}
	/**
	 * エラーチェック
	 */
	function lfCheckError(&$objFormParam) {
		$arrParams = $objFormParam->getHashArray();
		$arrErr = $objFormParam->checkError();
		if(!SC_Utils_Ex::isBlank($arrErr)) {
			return $arrErr;
		}
		$objError = new SC_CheckError_Ex($arrParams);
		$objError->doFunc(array('決済確定日', 'shipping_date_year', 'shipping_date_month', 'shipping_date_day')
							, array('EXIST_CHECK', 'CHECK_DATE'));
		$arrErr = array_merge($arrErr, $objError->arrErr);
		if(!SC_Utils_Ex::isBlank($objErr->arrErr)) {
			return $arrErr;
		}
	}
}
