<?php
require_once '../require.php';
require_once(CLASS_REALDIR . "pages/LC_Page.php");
require_once(CLASS_REALDIR . "util/SC_Utils.php");
require_once(CLASS_EX_REALDIR . "SC_Response_Ex.php");
require_once(MODULE_REALDIR . 'mdl_asjpayment/include.php');
require_once(MODULE_REALDIR . 'mdl_asjpayment/class_extends/SC_Util_MDL_ASJ_PAYMENT_Ex.php');

//ページ管理クラス
class LC_Page_LCA {
	//コンストラクタ
	function init() {
		//メインテンプレートの指定
		$this->tpl_title = "ASJペイメント決済";
	}
}

$objPage = new LC_Page();
$objView = null;
if($_SERVER["REQUEST_METHOD"] != "POST"){
	$method = 'get';
} else {
	$method = 'post';
}
$objFormParam = new SC_FormParam_Ex();
$objFormParam->setParam($_POST);
$mobile = 0;
if($method == 'get') {
	$mobile = $_GET['mobile'];
} else {
	$mobile = $_POST['mobile'];
}
if($mobile == '1'){
	$objView = new SC_MobileView;
	$objPage->tpl_mainpage = DATA_REALDIR . 'Smarty/templates/default/mobile/shopping/complete.tpl';
} else {
	$objView = new SC_SiteView;
	$objPage->tpl_mainpage = DATA_REALDIR . 'Smarty/templates/default/shopping/complete.tpl';
}

$objSiteInfo = $objView->objSiteInfo;

// ショップ情報出力
$objPage->arrInfo = $objSiteInfo->data;

$result = null;
if($method == 'get') {
	$result = $_GET['result'];
} else {
	$result = $_POST['result'];
}
// レスポンスパラメータで表示を切り替える
if($result == '0' || $result == '2' || isset($result) == FALSE){
	$objPage->dispParam = 'success';
} else {
	$objPage->dispParam = 'error';
}

function gfPrintLog($msg, $log_path) {
	GC_Utils::gfPrintLog($msg, $log_path);
}

$objQuery = new SC_Query();
$objSiteSess = new SC_SiteSession();
$objCartSess = new SC_CartSession();
$objCustomer = new SC_Customer();
$objDb = new SC_Helper_DB_Ex();
$objMail = new SC_Helper_Mail();

$objSiteInfo = $objView->objSiteInfo;
$arrInfo = $objSiteInfo->data;
$objPurchase = new SC_Helper_Purchase();
$objResponse = new SC_Response_Ex();
$objProduct = new SC_Product_Ex();

if(isset($result) == FALSE){
	// 受注をキャンセルし, カートをロールバック
	$objPurchase->rollbackOrder($_SESSION['order_id'], $orderStatus = ORDER_CANCEL, true);
	$arrPayment = $objQuery->getall("SELECT T2.memo03,T2.memo10 FROM dtb_order T1, dtb_payment T2 WHERE T1.payment_id = T2.payment_id and T1.order_id = ? ", $_SESSION['order_id']);
	if($arrPayment[0]["memo10"]) {
		$arrDataDetail = $objPurchase->getOrderDetail($_SESSION['order_id']);
		foreach ($arrDataDetail as $arrDetail) {
            if (!$objProduct->reduceStock($arrDetail['product_class_id'], $arrDetail['quantity'])) {
                $objQuery->rollback();
                SC_Utils_Ex::sfDispSiteError(SOLD_OUT, '', true);
            }
		}
	}
	// ページを表示
	//SC_Response_Ex::sendRedirect(SHOPPING_PAYMENT_URLPATH);
	$objResponse->sendRedirect(SHOPPING_PAYMENT_URLPATH);
	return;
}
$log_path = DATA_REALDIR . "logs/asjpayment.log";
gfPrintLog("**************************************** asjpayment start ****************************************", $log_path);
	if($result == '0' || $result == '2'){
		if($method == 'get') {
			$order_id = $_GET['charge'];
		} else {
			$order_id = $_POST['charge'];
		}
		$arrOrder = SC_Util_MDL_ASJ_PAYMENT_Ex::getOrderPayData($order_id);
		if($arrOrder['status'] == ORDER_PENDING) {
			$arrPayment = $objQuery->getall("SELECT memo01,memo03,memo05,memo06,memo09,memo10 FROM dtb_payment WHERE payment_id = ? ", $arrOrder["payment_id"]);
			$updated_flg = 0;
			if($order_id > 0 && $arrPayment[0]["memo10"]) {
				$arrOrder = SC_Util_MDL_ASJ_PAYMENT_Ex::getOrderPayData($order_id);
				if($arrOrder["memo09"] && $arrOrder["memo09"] == "1") {
					/* 二重呼び出しにより更新済 */
					$updated_flg = 1;
				} else {
					/* 呼び出し済の値を登録 */
					$objQuery->update('dtb_order', array(),
						'order_id = ?', array($order_id),
						array('memo09' => '?'), array('1'));
				}
			}
			$objQuery->begin();
			/* 決済後の在庫管理の場合在庫を減らす。足りない場合は決済キャンセル */
			if($arrPayment[0]["memo10"] && $updated_flg == 0) {
				$arrDataDetail = $objPurchase->getOrderDetail($order_id);
				foreach ($arrDataDetail as $arrDetail) {
		            if (!$objProduct->reduceStock($arrDetail['product_class_id'], $arrDetail['quantity'])) {
		                $objQuery->rollback();
						$objPurchase->rollbackOrder($order_id, $orderStatus = ORDER_CANCEL, true);
						foreach ($arrDataDetail as $arrDetail) {
							$objProduct->reduceStock($arrDetail['product_class_id'], $arrDetail['quantity']);
						}
						$arrSendData = array(
							'charge'		=> $order_id				// 決済番号
							, 'version'     => ECCUBE_VERSION. "_" .MDL_ASJPAYMENT_VERSION            // 決済モジュールバージョン番号
							, 'admin'       => $arrPayment[0]["memo01"]	// 契約者番号
							, 'login'       => $arrPayment[0]["memo05"]	// ログインID
							, 'pass'        => $arrPayment[0]["memo06"]	// パスワード
						);
						$option = array(
						    CURLOPT_RETURNTRANSFER => true,
						    CURLOPT_URL        => MDL_ASJPAYMENT_AFTERSTOCK_CANCELURL,
						    CURLOPT_POST	=>	true,
						    CURLOPT_POSTFIELDS	=>	http_build_query($arrSendData),
						);
						$ch = curl_init();
						curl_setopt_array($ch, $option);
					    curl_exec($ch);
						curl_close($ch);
		                SC_Utils_Ex::sfDispSiteError(SOLD_OUT, '', true);
						$objResponse->sendRedirect(SHOPPING_PAYMENT_URLPATH);
						return;
		            }
				}
			}

			/*アトディーネで結果が申請中の時は決済処理中にする。そうでない場合は入金完了*/
			if($arrPayment[0]["memo03"] - 50 == 4 && $result == '2') {
				$objPurchase->sfUpdateOrderStatus($order_id, MTB_ORDER_STATUS_ATODENE_REVIEW, null, null, $arrValues);
				$arrOrder['status'] = MTB_ORDER_STATUS_ATODENE_REVIEW;
			} else if($arrPayment[0]["memo03"] - 50 == 7 && $result == '2') {
				$objPurchase->sfUpdateOrderStatus($order_id, MTB_ORDER_STATUS_ATOBARAI_REVIEW, null, null, $arrValues);
				$arrOrder['status'] = MTB_ORDER_STATUS_ATOBARAI_REVIEW;
			} else {
				$objPurchase->sfUpdateOrderStatus($order_id, ORDER_PRE_END, null, null, $arrValues);
				$arrOrder['status'] = ORDER_PRE_END;
			}
			if(!SC_Utils_Ex::isBlank($arrOrder)
			&& $arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_SPFLG] == 'regular'
			&& $arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_SPDATA] == ''
			&& ($arrOrder['status'] == ORDER_NEW || $arrOrder['status'] == ORDER_PRE_END || $arrOrder['status'] == ORDER_PAY_WAIT)) {
				if($method == 'get') {
					$regular_id = $_GET['regular_id'];
				} else {
					$regular_id = $_POST['regular_id'];
				}
				// 定期購入番号が取得できない
				if(intval($regular_id) <= 0) {
					$log_path = DATA_REALDIR . "logs/asjpayment.log";
					gfPrintLog("!!!!!!!!!!!! asjpayment error !!!!!!!!!!!!!!", $log_path);
					gfPrintLog(sprintf("get regular error!! order(%s)", $arrOrder['order_id']), $log_path);
					SC_Utils_Ex::sfDispSiteError(FREE_ERROR_MSG, "", true, "購入手続きが正しく行われませんでした。<br />大変お手数ですが、サイト管理者までご連絡ください。");
				}
				/* min_day取得用 */
				$objMdl =& SC_MDL_ASJ_PAYMENT_Ex::getInstance();
				$arrSubData = $objMdl->getSubData('reg');

				$objPurchase = new SC_Helper_Purchase_Ex();
				$sqlval = array();
				$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_SPDATA] = MDL_PG_ASJ_PAYMENT_REG_STATUS_NEW;
				$objPurchase->sfUpdateOrderStatus($order_id, null, null, null, $sqlval);
				// subs_order
				$arrOrderDetail = $objPurchase->getOrderDetail($arrOrder['order_id'], false);
				$table = 'plg_AsjPgReg_order';
				$arrCols = $objQuery->listTableFields($table);
				foreach($arrOrderDetail as $arrDetail) {
					$sqlval = array();
					foreach($arrDetail as $key => $val) {
						if(in_array($key, $arrCols)) {
							$sqlval[$key] = $val;
						}
					}
					$sqlval['customer_id'] = $arrOrder['customer_id'];
					$sqlval['first_order_id'] = $arrOrder['order_id'];
					$sqlval['last_order_id'] = $arrOrder['order_id'];
					$sqlval['payment_id'] = $arrOrder['payment_id'];
					$sqlval['deliv_id'] = $arrOrder['deliv_id'];
					$sqlval['order_pref'] = $arrOrder['order_pref'];
					$sqlval['order_count'] = 1;

					//購入を来月とみなす期日
					if($arrSubData['reg_order_min_day'] > 0
					&& date('d', time()) >= $arrSubData['reg_order_min_day']) {
						$sqlval['status'] = MDL_PG_ASJ_PAYMENT_REG_STATUS_MIN_SPAN;
					} else {
						$sqlval['status'] = MDL_PG_ASJ_PAYMENT_REG_STATUS_SALES;
					}

					$sqlval['del_flg'] = '0';
					$sqlval['create_date'] = $arrOrder['create_date'];
					$sqlval['update_date'] = 'NOW()';
					if($arrSubData['reg_order_min_day'] > 0
					&& date('d', time()) >= $arrSubData['reg_order_min_day']) {
						$sqlval['min_day'] = $arrSubData['reg_order_min_day'];
					} else {
						$sqlval['min_day'] = '0';
					}
					$table = 'plg_AsjPgReg_order';
					$seq_name = $table . 'reg_order_id';
					$sqlval['reg_order_id'] = $objQuery->nextVal($seq_name);

					$ret = $objQuery->insert($table, $sqlval);
					$subs_order_id = $sqlval['reg_order_id'];		// 定期購入ID
					$arrPayData = array();
					$arrPayData['pay_mode'] = 'subscription';
					$arrPayData['Amount'] = $arrOrder['payment_total'];
					$arrPayData['RegularAmount'] = $arrOrder['total'];
					$arrPayData['JobCd'] = 'CAPTURE';
					$arrPayData['reg_order_id'] = $subs_order_id;
					$arrPayData['action_status'] = MDL_PG_ASJPAYMENT_ACTION_STATUS_EXEC_REQUEST;
					$arrPayData['pay_status'] = MDL_PG_ASJPAYMENT_PAY_STATUS_UNSETTLED;

					SC_Util_MDL_ASJ_PAYMENT_Ex::setOrderPayData($arrOrder, $arrPayData);
					$table = "dtb_AsjPgReg_order_to_regular";
					$sqlval = array();
					$sqlval['reg_order_id'] = $subs_order_id;
					$sqlval['regular_id'] = $regular_id;
					$ret = $objQuery->insert($table, $sqlval);
				}
			}
			// 完了メール送信
			$count = $objQuery->count("dtb_mail_history", "order_id = ?", array($order_id));
			if($count == 0) {
				$objMail->sfSendOrderMail($order_id, '1');
			}
		}
		$objQuery->commit();
		// ページを表示
		$objResponse->sendRedirect(SHOPPING_COMPLETE_URLPATH);
	} else {
		// 受注をキャンセルし, カートをロールバック
		if($method == 'get') {
			$charge = $_GET['charge'];
		} else {
			$charge = $_POST['charge'];
		}
		$objPurchase->rollbackOrder($charge, $orderStatus = ORDER_CANCEL, true);
		// エラーの場合受信データを送信
		$log_path = DATA_REALDIR . "logs/asjpayment.log";
		gfPrintLog("!!!!!!!!!!!! asjpayment error !!!!!!!!!!!!!!", $log_path);
		$arrPayment = $objQuery->getall("SELECT T2.memo03,T2.memo10 FROM dtb_order T1, dtb_payment T2 WHERE T1.payment_id = T2.payment_id and T1.order_id = ? ", $charge);
		if($arrPayment[0]["memo10"]) {
			$arrDataDetail = $objPurchase->getOrderDetail($charge);
			foreach ($arrDataDetail as $arrDetail) {
	            if (!$objProduct->reduceStock($arrDetail['product_class_id'], $arrDetail['quantity'])) {
	                $objQuery->rollback();
	                SC_Utils_Ex::sfDispSiteError(SOLD_OUT, '', true);
	            }
			}
		}
		if(($arrPayment[0]["memo03"] - 50 == 4) || ($arrPayment[0]["memo03"] - 50 == 7)) {
			$log_path = DATA_REALDIR . "logs/asjpayment.log";
			gfPrintLog("**************************************** asjpayment end ****************************************", $log_path);
			$objResponse->sendRedirect(SHOPPING_PAYMENT_URLPATH);
			return;
		} else {
			SC_Utils_Ex::sfDispSiteError(FREE_ERROR_MSG, "", true, "クレジットカード決済できませんでした。<br />別のクレジットカードをご利用になるかお支払方法を変更して<br />もう一度、購入手続きを行ってください。");
		}
	}
$log_path = DATA_REALDIR . "logs/asjpayment.log";
gfPrintLog("**************************************** asjpayment end ****************************************", $log_path);
