<?php

require_once(MODULE_REALDIR . 'mdl_asjpayment/include.php');

/**
 * σW[p ėp֐
 */
class SC_Util_MDL_ASJ_PAYMENT {

	function getOrderPayData($order_id) {
		$objPurchase = new SC_Helper_Purchase_Ex();
		$arrOrder = $objPurchase->getOrder($order_id);
		if($arrOrder['del_flg'] == '1') {
			$objMdl =& SC_Util_MDL_ASJ_PAYMENT_Ex::getInstance();
			$objMdl->printLog('getOrderPayData Error: deleted order. order_id = ' . $order_id);
			return false;
		}
		if(SC_Utils_Ex::isBlank($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA])) {
			$arrPayData = array();
		} else {
			$arrPayData = unserialize($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA]);
		}
		if(SC_Utils_Ex::isBlank($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG])) {
			$arrPayData['payment_log'] = array();
		} else {
			$arrPayData['payment_log'] = unserialize($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG]);
		}
		if(isset($arrPayData[0]) and is_array($arrPayData[0])) {
			$arrTemp = $arrPayData[0];
			unset($arrPayData[0]);
			$arrData = array_merge((array)$arrData, (array)$arrTemp);
		}
		$arrOrder = array_merge($arrOrder, (array)$arrPayData);
		return $arrOrder;
	}

	function setOrderPayData($arrOrder, $arrData, $is_only_log = false) {
		if(isset($arrData[0]) and is_array($arrData[0])) {
			$arrTemp = $arrData[0];
			unset($arrData[0]);
			$arrData = array_merge((array)$arrData, (array)$arrTemp);
		}
		foreach($arrData as $key => $val) {
			if(!$val || preg_match('/^[\w\s]+$/i', $val)) {
				continue;
			}
			$temp = mb_convert_encoding($val, 'sjis-win', CHAR_CODE);
			$temp = mb_convert_encoding($temp, CHAR_CODE, 'sjis-win');
			if($val !== $temp) {
				$temp = mb_convert_encoding($val, CHAR_CODE, 'sjis-win');
				$temp = mb_convert_encoding($temp, 'sjis-win', CHAR_CODE);
				if($val === $temp) {
					$arrData[$key] = mb_convert_encoding($val, CHAR_CODE, 'sjis-win');
				} else {
					$arrData[$key] = 'unknown encoding strings';
				}
			}
		}

		$objPurchase = new SC_Helper_Purchase_Ex();
		$objQuery =& SC_Query_Ex::getSingletonInstance();
		$objQuery->begin();
		$sqlval = array();

		$arrOrder = $objPurchase->getOrder($arrOrder['order_id']);
		if(SC_Utils_Ex::isBlank($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG])) {
			$arrLog = array();
		} else {
			$arrLog = unserialize($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG]);
		}
		$arrLog[] = array( date('Y-m-d H:i:s') => $arrData );
		$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG] = serialize($arrLog);

		if(!$is_only_log) {
			if(SC_Utils_Ex::isBlank($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA])) {
				$arrPayData = array();
			} else {
				$arrPayData = unserialize($arrOrder[MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA]);
			}
			foreach($arrData as $key => $val) {
				if(SC_Utils_Ex::isBlank($val) && !SC_Utils_Ex::isBlank($arrPayData[$key])) {
					unset($arrData[$key]);
				}
			}

			$arrPayData = array_merge($arrPayData, (array)$arrData);

			$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA] = serialize($arrPayData);

			if(!SC_Utils_Ex::isBlank($arrData['pay_status'])) {
				$sqlval[MDL_PG_ASJPAYMENT_ORDER_COL_PAYSTATUS] = $arrData['pay_status'];
			}
		}

		$objMdl =& SC_MDL_ASJ_PAYMENT_Ex::getInstance();
		if(MDL_PG_ASJPAYMENT_DEBUG) {
			$arrBacktrace = debug_backtrace();
			if(is_object($arrBacktrace[0]['object'])) {
				$class_name = get_class($arrBacktrace[0]['object']);
				$parent_class_name = get_parent_class($arrBacktrace[0]['object']);
				$class_msg = $parent_class_name . ' -> ' . $class_name . ' -> ';
			}
		} else {
			$class_msg = basename($_SERVER["SCRIPT_NAME"]);
		}
		$objMdl->printLog($class_msg . ' set payment data:' . print_r($arrData, true));

		$newStatus = null;
		$objPurchase->sfUpdateOrderStatus($arrOrder['order_id'], $newStatus, null, null, $sqlval);
		$objQuery->commit();
	}

}
