<?php
/**
 *
 * @copyright	2010 ASJ CO.,LTD. All Rights Reserved.
 *
 */

$asjpayment_credit_php_dir = realpath(dirname( __FILE__));
// include_pathにmdl_asjpaymentのパスを含める
ini_set('include_path', $asjpayment_credit_php_dir . PATH_SEPARATOR . ini_get('include_path'));

define('MDL_ASJPAYMENT_SERVICE_NAME', 'ＡＳＪペイメント');
define('MDL_ASJPAYMENT_MODULE_NAME', 'ＡＳＪペイメント決済モジュール');
define('MDL_ASJPAYMENT_COMPANY_NAME', 'ＡＳＪ');
define('MDL_ASJPAYMENT_INFO_URI', 'http://www.asj.ad.jp/');

define("MDL_ASJPAYMENT_CODE", "mdl_asjpayment");
define("MDL_ASJPAYMENT_SPFLG_STR", "regular");

define("MDL_ASJPAYMENT_REGULAR_KIND_WEEKLY", "5");				// 毎週○曜日
define("MDL_ASJPAYMENT_REGULAR_KIND_EVERY_OTHER_WEEK", "6");	// 隔週○曜日
define("MDL_ASJPAYMENT_REGULAR_KIND_MONTH_WEEK", "7");			// 毎月第○週○曜日
define("MDL_ASJPAYMENT_REGULAR_KIND_MONTH_DAY", "8");			// 毎月○日
define("MDL_ASJPAYMENT_REGULAR_KIND_LAST_DAY", "9");			// 毎月末日
define("MDL_ASJPAYMENT_REGULAR_KIND_MONTH", "1");				// 1ヶ月毎
define("MDL_ASJPAYMENT_REGULAR_KIND_3MONTH", "2");				// 3ヶ月毎
define("MDL_ASJPAYMENT_REGULAR_KIND_6MONTH", "3");				// 6ヶ月毎
define("MDL_ASJPAYMENT_REGULAR_KIND_12MONTH", "4");				// 12ヶ月毎
define('MDL_ASJPAYMENT_VERSION', "20231212");

// 受注データ毎の情報保存カラム設定
define('MDL_PG_ASJPAYMENT_ORDER_COL_PAYVIEW', 'memo02');
define('MDL_PG_ASJPAYMENT_ORDER_COL_PAYID', 'memo03');
define('MDL_PG_ASJPAYMENT_ORDER_COL_PAYSTATUS', 'memo04');
define('MDL_PG_ASJPAYMENT_ORDER_COL_PAYDATA', 'memo05');
define('MDL_PG_ASJPAYMENT_ORDER_COL_SPFLG', 'memo06');
define('MDL_PG_ASJPAYMENT_ORDER_COL_SPDATA', 'memo07');
define('MDL_PG_ASJPAYMENT_ORDER_COL_TRANSID', 'memo08');
define('MDL_PG_ASJPAYMENT_ORDER_COL_PAYLOG', 'memo09');
define('MDL_PG_ASJPAYMENT_ORDER_COL_AFTERSTOCK', 'memo10');
// 支払い方法毎の情報保存カラム設定
define('MDL_PG_ASJPAYMENT_PAYMENT_COL_PAYID', 'memo03');
define('MDL_PG_ASJPAYMENT_PAYMENT_COL_CONFIG', 'memo05');

define('MDL_ASJPAYMENT_AFTERSTOCK_CANCELURL', 'https://www.asjpayment.jp/cgi-bin/ps_charge_cancel_ec.cgi');

////////////////////////////////////////////////////////////////////////////////
// モジュール基本設定
define('MDL_PG_ASJPAYMENT', true);
define('MDL_PG_ASJPAYMENT_CODE', 'MDL_PG_ASJPAYMENT');
// モジュールデバッグ設定
// true の場合、顧客の入力内容がログに残りますので運用時は必ずfalseにして下さい。
define('MDL_PG_ASJPAYMENT_DEBUG', false);
// モジュールパス設定
define('MDL_PG_ASJPAYMENT_PATH', MODULE_REALDIR . 'mdl_asjpayment/');
define('MDL_PG_ASJPAYMENT_CLASS_PATH', MDL_PG_ASJPAYMENT_PATH.'class/');
define('MDL_PG_ASJPAYMENT_CLASSEX_PATH', MDL_PG_ASJPAYMENT_PATH.'class_extends/');
define('MDL_PG_ASJPAYMENT_MODULE_PATH', MDL_PG_ASJPAYMENT_PATH.'module/');
define('MDL_PG_ASJPAYMENT_TEMPLATE_PATH', MDL_PG_ASJPAYMENT_PATH.'templates/');
// エラーメッセージファイル
define('MDL_PG_ASJPAYMENT_ERROR_CODE_MSG_FILE', MDL_PG_ASJPAYMENT_PATH .'inc/pg_asjpgreg_errors.txt');
// 決済通知先
define('MDL_PG_ASJPAYMENT_SETTLEMENT_FILE', 'asjpayment_recv.php');
define('MDL_PG_ASJPAYMENT_SETTLEMENT_URL', HTTPS_URL . USER_DIR . MDL_PG_ASJPAYMENT_SETTLEMENT_FILE);
define('MDL_PG_ASJPAYMENT_SETTLEMENT_PATH', USER_REALDIR . MDL_PG_ASJPAYMENT_SETTLEMENT_FILE);
// メディアファイル設置先
define('MDL_PG_ASJPAYMENT_MEDIAFILE_URL', HTTPS_URL . USER_DIR . MDL_PG_ASJPAYMENT_CODE . '/');
define('MDL_PG_ASJPAYMENT_MEDIAFILE_PATH', USER_REALDIR . MDL_PG_ASJPAYMENT_CODE . '/');
// 決済タイプ (EC-CUBE内の決済種別 識別ID)
define('MDL_PG_ASJPAYMENT_PAYID_CREDIT', '10');
define('MDL_PG_ASJPAYMENT_PAYID_REGIST_CREDIT', '11');
define('MDL_PG_ASJPAYMENT_PAYID_CREDIT_CHECK', '12');
define('MDL_PG_ASJPAYMENT_PAYID_CREDIT_SAUTH', '12');
define('MDL_PG_ASJPAYMENT_PAYID_CVS', '20');
define('MDL_PG_ASJPAYMENT_PAYID_PAYEASY', '30');
define('MDL_PG_ASJPAYMENT_PAYID_ATM', '31');
define('MDL_PG_ASJPAYMENT_PAYID_MOBILEEDY', '40');
define('MDL_PG_ASJPAYMENT_PAYID_MOBILESUICA', '50');
define('MDL_PG_ASJPAYMENT_PAYID_PAYPAL', '60');
define('MDL_PG_ASJPAYMENT_PAYID_IDNET', '70');
define('MDL_PG_ASJPAYMENT_PAYID_WEBMONEY', '80');
define('MDL_PG_ASJPAYMENT_PAYID_AU', '90');
define('MDL_PG_ASJPAYMENT_PAYID_DOCOMO', '92');
define('MDL_PG_ASJPAYMENT_PAYID_SB', '95');
define('MDL_PG_ASJPAYMENT_PAYID_BANKTRANS', '100');
define('MDL_PG_ASJPAYMENT_PAYID_COLLECT', '900');
// 操作状態
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_UNSETTLED', 0);			// 操作前
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_ENTRY_REQUEST', 1);		// 取引登録要求
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_ENTRY_SUCCESS', 2);		// 取引登録成功
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_EXEC_REQUEST', 3);		// 決済要求
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_EXEC_SUCCESS', 6);		// 決済要求成功
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_EXEC_FAIL', 7);			// 決済要求失敗
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_WAIT_NOTICE', 4);		// 通知待ち
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_RECV_NOTICE', 5);		// 通知受信(済)
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_EXPIRE', 8);			// 期限切れ
define('MDL_PG_ASJPAYMENT_ACTION_STATUS_CANCEL', 9);			// キャンセル
// 決済状態
define('MDL_PG_ASJPAYMENT_PAY_STATUS_UNSETTLED', 0);		// 未決済
define('MDL_PG_ASJPAYMENT_PAY_STATUS_UNPROCESSED', MDL_PG_ASJPAYMENT_PAY_STATUS_UNSETTLED);		// 未決済
define('MDL_PG_ASJPAYMENT_PAY_STATUS_AUTHENTICATED', MDL_PG_ASJPAYMENT_PAY_STATUS_UNSETTLED);	// 未決済
define('MDL_PG_ASJPAYMENT_PAY_STATUS_AUTHPROCESS', MDL_PG_ASJPAYMENT_PAY_STATUS_UNSETTLED);		// 未決済
define('MDL_PG_ASJPAYMENT_PAY_STATUS_REQUEST_SUCCESS', 1);// 要求成功
define('MDL_PG_ASJPAYMENT_PAY_STATUS_REQSUCCESS', MDL_PG_ASJPAYMENT_PAY_STATUS_REQUEST_SUCCESS);// 要求成功
define('MDL_PG_ASJPAYMENT_PAY_STATUS_PAY_SUCCESS', 2);	// 支払い完了
define('MDL_PG_ASJPAYMENT_PAY_STATUS_PAYSUCCESS', MDL_PG_ASJPAYMENT_PAY_STATUS_PAY_SUCCESS);	// 支払い完了

define('MDL_PG_ASJPAYMENT_PAY_STATUS_EXPIRE', 3);		// 期限切れ
define('MDL_PG_ASJPAYMENT_PAY_STATUS_CANCEL', 4);		// キャンセル(PayPal)
define('MDL_PG_ASJPAYMENT_PAY_STATUS_FAIL', 99);		// 決済失敗
define('MDL_PG_ASJPAYMENT_PAY_STATUS_PAYFAIL', MDL_PG_ASJPAYMENT_PAY_STATUS_FAIL);	// 決済失敗

// 決済通信タイムアウト値 (接続タイムアウト、ソケットタイムアウト共通)
define('MDL_PG_ASJPAYMENT_HTTP_TIMEOUT', 10);

// 遷移URLデフォルト
define("MDL_PG_ASJPAYMENT_COMPLETE_URL", HTTPS_URL . "shopping/load_payment_module.php");	// 信用要求成功URL
define("MDL_PG_ASJPAYMENT_RETURN_URL", HTTPS_URL  . "shopping/load_payment_module.php");	// キャンセル時
define("MDL_PG_ASJPAYMENT_ERROR_URL", HTTPS_URL  . "shopping/load_payment_module.php");		// エラー時

// 処理区分
$arrJobCd = array(
    'AUTH',
    'CHECK',
    'CAPTURE',
    'SAUTH',
);

// 支払上限金額
define('CONVENI_RULE_MAX', 299999);
define('SUICA_RULE_MAX', 20000);
define('EDY_RULE_MAX', 50000);
define('CREDIT_RULE_MAX', 999999);
define('PAYEASY_RULE_MAX', 999999);
define('PAYPAL_RULE_MAX', 999999);
define('WEBMONEY_RULE_MAX', 999999);
define('NETID_RULE_MAX', 999999);
define('AU_RULE_MAX', 9999999);
define('DOCOMO_RULE_MAX', 30000);
define('SB_RULE_MAX', 10000);

//定期購入フラグ
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_NEW', '1');			// 新規依頼
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_WAIT', '2');			// 次回待機（キャンセル可能）
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_WAIT_NOCANCEL', '3');		// 次回待機（キャンセル不可能）
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_CANCEL_REQUEST', '4');		// キャンセル依頼中
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_CANCEL', '5');			// キャンセル済み
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_PENDING', '6');			// 売上処理中
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_SALES', '7');			// 売上成功・発送手配中
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_SALES_FAIL', '8');		// 売上失敗
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_END', '9');			// 終了・完了
define('MDL_PG_ASJ_PAYMENT_REG_STATUS_MIN_SPAN', '10');			// 二回目の決済が同月に発生する
define('MDL_PG_ASJ_PAYMENT_REG_PURCHASE_DAY',  '27');			// 定期購入末日

//決済ステータス(アトディーネ)
define('MTB_ORDER_STATUS_ATODENE_REVIEW', 1000);
define('MTB_ORDER_STATUS_ATOBARAI_REVIEW', 1000);

require_once(MDL_PG_ASJPAYMENT_CLASSEX_PATH . 'SC_MDL_ASJ_PAYMENT_Ex.php');
require_once(MDL_PG_ASJPAYMENT_CLASSEX_PATH . 'SC_Util_MDL_ASJ_PAYMENT_Ex.php');

////////////////////////////////////////////////////////////////////////////////
//決済の種類
$arrPayment = array(
		1 => 'クレジット',

		);

$arrCredit = array(
		1 => 'VISA, MASTER, Diners',
		2 => 'JCB, AMEX'
		);

/**************************************************************************************************************
 * 関数名	：sfGetXMLValue
 * 処理内容	：XMLタグの内容を取得する
 * 引数1	：$arrVal	･･･ Valueデータ
 * 引数2	：$tag		･･･ Tagデータ
 * 引数3	：$att		･･･ 対象タグ名
 * 戻り値	：取得結果
 **************************************************************************************************************/
function sfGetXMLValue($arrVal, $tag, $att) {
	$ret = "";
	foreach((array)$arrVal as $array) {
		if($tag == $array['tag']) {
			if(!is_array($array['attributes'])) {
				continue;
			}
			foreach($array['attributes'] as $key => $val) {
				if($key == $att) {
					$ret = mb_convert_encoding(urldecode($val), 'UTF-8', 'SJIS');
					break;
				}
			}
		}
	}

	return $ret;
}

/**************************************************************************************************************
 * 関数名	：sfPostPaymentData
 * 処理内容	：ASJペイメントへデータを送信する。（未使用）
 * 引数1	：$order_url	･･･ 送信先URL
 * 引数2	：$arrData		･･･ POSTデータ
 **************************************************************************************************************/
function sfPostPaymentData($order_url, $arrData, $err_page = true){
	$arrVal = array();
	$response = "";

	// POSTデータを送信し、応答情報を取得する
	$response = SC_Utils_Ex::sfSendPostData($order_url, $arrData, array(200));

	// なにも返ってこなれば、エラー
	if ($response == "") {
		if ($err_page) {
			// エラー画面を表示する。
			$_SESSION['site']['now_page'] ="";
			SC_Utils_Ex::sfDispSiteError(FREE_ERROR_MSG, "", true, "購入処理中にエラーが発生しました。<br>この手続きは無効となりました。");
		}else{
			return "" ;
		}
	}

	return $response;
}

/**************************************************************************************************************
 * 関数名	：lfCreateEditSetSendData
 * 処理内容	：送信内容
 * 引数1	：
 * 引数2	：
 **************************************************************************************************************/
function lfCreateEditSetSendData($arrData, $arrPayment) {
	$arrSendData = array(
		'version'=> MDL_ASJPAYMENT_VERSION						// 決済モジュールバージョン番号
		, 'admin'			=> $arrPayment[0]["memo01"]			// 契約者番号
		, 'login'			=> $arrPayment[0]["memo05"]			// ログインID
		, 'pass'			=> $arrPayment[0]["memo06"]			// パスワード
		, 'send_url'		=> $arrPayment[0]["memo07"]			// 同期URL
		//, 'SHOPCO'		=> $arrPayment[0]["memo01"]			// 店舗コード
		//, 'HOSTID'		=> $arrPayment[0]["extset_host_id"]	// 拡張セット用のホストID
		//, 'S_TORIHIKI_NO'	=> $arrData["order_id"]				// オーダー番号
		, 'charge'			=> $arrData["order_id"]				// オーダー番号
		//, 'TRANID'		=> $arrData["credit_result"]		// トランザクションID
		, 'tranid'			=> $arrData["credit_result"]		// トランザクションID
		//, 'RETURL'		=> HTTPS_URL . 'user_data/remise_extset.php'	// 完了通知URL
		//, 'NG_RETURL'	=> HTTPS_URL . 'user_data/remise_extset.php'		// NG完了通知URL
		, 'return'			=> HTTP_URL . ADMIN_DIR . 'order/asjpayment_edit.php'	// 完了通知URL
		, 'ng_return'		=> HTTP_URL . ADMIN_DIR . 'order/asjpayment_edit.php'	// NG完了通知URL
	);
	return $arrSendData;
}
