<?php

/**
 * 管理画面をカスタマイズ時のファイル上書き
 */

class install{
	var $install_files;

	/**
	 * コンストラクタ
	 */
	function install($customize) {
		$this->install_files = array();
		// バージョン毎にモジュールわかれているので判定しません。
		array_push($this->install_files
			, array("source" => MODULE_REALDIR . 'mdl_asjpayment/inst/order/index.tpl'
					, "dest" => TEMPLATE_ADMIN_REALDIR . 'order/index.tpl'
					, "overwrite" => $customize
					, "backup" => true)
			, array("source" => MODULE_REALDIR . 'mdl_asjpayment/inst/order/edit.tpl'
					, "dest" => TEMPLATE_ADMIN_REALDIR . 'order/edit.tpl'
					, "overwrite" => $customize
					, "backup" => true)
			, array("source" => MODULE_REALDIR . 'mdl_asjpayment/inst/order/LC_Page_Admin_Order_Edit_Ex.php'
					, "dest" => DATA_REALDIR . 'class_extends/page_extends/admin/order/LC_Page_Admin_Order_Edit_Ex.php'
					, "overwrite" => $customize
					, "backup" => true)
			, array("source" => MODULE_REALDIR . 'mdl_asjpayment/inst/order/LC_Page_Admin_Order_Ex.php'
					, "dest" => DATA_REALDIR . 'class_extends/page_extends/admin/order/LC_Page_Admin_Order_Ex.php'
					, "overwrite" => $customize
					, "backup" => true)
		);
	}

	/**
	 * ファイルコピー.
	 */
	function filecopy() {
		$objUtils = new SC_Utils();
		$errmsg = "";

		foreach($this->install_files as $file) {
			$source = $file['source'];
			$dest = $file['dest'];
			$overwrite = $file['overwrite'];
			$backup = $file['backup'];

			//ファイルがないか、もしくはオーバーライト可の場合
			if(!file_exists($dest) || $overwrite) {
				if(is_dir($source)){
					// ディレクトリの場合
					$objUtils->sfMakeDir($dest);
					$backupfile = dirname($dest) . '/' . basename($dest) . '_' . date("Ymdhis") . '.backup';
					if($backup){
						$objUtils->sfCopyDir($dest, $backupfile);
					}
					// フォルダをコピー
					$objUtils->sfCopyDir($source, $dest, $message, true);
				} else {
					$backupfile = $file['dest'] . '_' . date("Ymdhis") . '.backup';
					//バックアップを作成(ファイルが異なる場合のみ)
					if($backup && (!file_exists($backupfile) || sha1_file($source) != sha1_file($backupfile))) {
						copy($dest, $backupfile);
					}
					//ファイルをコピー
					if(is_writable($dest) || is_writable(dirname($dest))) {
						copy($source, $dest);
					} else {
						$errmsg .= $dest . "に書き込み権限を与えてください。";
						break;
					}
				}
			}
		}
		return $errmsg;
	}

	/**
	 * 
	 */
	function setInstallFiles($val) {
		$this->install_files = $val;
	}

	/**
	 * 
	 */
	function getInstallFiles() {
		return $this->install_files;
	}
}
