<?php
/*
 * This file is part of EC-CUBE
 *
 * Copyright(c) 2000-2013 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

// {{{ requires

require_once CLASS_REALDIR . 'pages/admin/order/LC_Page_Admin_Order_Edit.php';
// ASJペイメントモジュール
require_once(MODULE_REALDIR . 'mdl_asjpayment/include.php');

/**
 * 受注修正 のページクラス(拡張).
 *
 * LC_Page_Admin_Order_Edit をカスタマイズする場合はこのクラスを編集する.
 *
 * @package Page
 * @author LOCKON CO.,LTD.
 * @version $Id: LC_Page_Admin_Order_Edit_Ex.php,v 1.1 2014/03/07 04:32:32 iwashi Exp $
 */
class LC_Page_Admin_Order_Edit_Ex extends LC_Page_Admin_Order_Edit {
	/**
	 * Page を初期化する.
	 */
	function init() {
		parent::init();
	}

	/**
	 * Page のプロセス.
	 */
	function process() {
		parent::process();
	}

	/**
	 * Page のアクション.
	 */
	function action() {
		parent::action();
	}

	/**
	 * デストラクタ.
	 */
	function destroy() {
		parent::destroy();
	}

	/**
	 * パラメーター情報の初期化
	 */
	function lfInitParam(&$objFormParam) {
		parent::lfInitParam($objFormParam);
		$objFormParam->addParam("ASJペイメントクレジットカード決済", "asj_payment_id");
	}

	/**
	 * 受注データを取得して, SC_FormParam へ設定する
	 */
	function setOrderToFormParam(&$objFormParam, $order_id) {
		parent::setOrderToFormParam($objFormParam, $order_id);

		$objQuery =& SC_Query_Ex::getSingletonInstance();
		$arrAsjPayment = $objQuery->getRow('payment_id', 'dtb_payment', 'module_code = ?', array(MDL_ASJPAYMENT_CODE));
		if(SC_Utils_Ex::isBlank($arrAsjPayment)) {
			return;
		}
		if(SC_Utils_Ex::isBlank($objFormParam->getValue('commit_date'))) {
			$objFormParam->setValue('asj_payment_id', $arrAsjPayment['payment_id']);
		}
	}
}
